<id>
Board Index User Cache for YaBB 2
</id>

<version>
1.4 (YaBB 2.1)
</version>

<mod info>
Adds a caching ability for the user files to the BoardIndex.pl. MessageIndex.pl also uses this cache a little. This should result in a lot less opened files when viewing the BoardIndex and possibly the MessageIndex.

** This mod will not do well with mods that display user information except for username, displayname, regdate, regtime, position, or addgroups on the BoardIndex or MessageIndex.

To install:
Use BoardMod like normal
Upload these files in Sources/: BoardIndex.pl, MessageIndex.pl, Profile.pl
Upload these files in Admin/: Modlist.pl, AdminSubList.pl, BIUC.pl (provided in zip)
Upload AdminIndex.pl
Upload Languages/English/BIUC.lng (provided in zip)

Version History:
1.4 (YaBB 2.1): Updated for 2.1. Added eval() for topic listing too. Added German translation. Changed the directory structure of the mod zip file to make it more like the real YaBB structure. (November 10th, 2005)
1.3 (YaBB 2 Final): Used eval() to trap errors created by the cache. (October 25th, 2005)
1.2 (YaBB 2 Final): Fixed regtime error with Guests. (October 12th, 2005)
1.1 (YaBB 2 Final): Made storing of data safer. Also fixed dates in headers of the lang and admin files. (October 8th, 2005)
1.0 (YaBB 2 Final): Mod package made available on BoardMod. (October 7th, 2005)
</mod info>

<author>
AK108
</author>

<homepage>
http://fkp.jkcsi.com/
</homepage>

<edit file>
Sources/BoardIndex.pl
</edit file>

<search for>
LoadLanguage("BoardIndex");
require "$templatesdir/$useboard/BoardIndex.template";
</search for>

<add after>

### AK108 Board Index User Cache
if(-e "$vardir/boardindexusers.cache") {
	# Trap any syntax errors that might be in the file
	eval 'require "$vardir/boardindexusers.cache"';

	# You can trap errors here by uncommenting the following if statement
	# And putting something inside the block
	#if($@) {} # the code in the if block is executed if there is an error

	# It is probably a good idea to remove the file if it's bad.
	if($@) {unlink "$vardir/boardindexusers.cache";}
}
</add after>

<search for>
1;
</search for>

<add before>
### AK108 Board Index User Cache
sub RecacheUsers {
	my($user, $trash, $tag, $value, $output, $writecache, @userlist);
	while(($user, $trash) = each(%memberaddgroup)) {
		if($user eq 'Guest') {next;}
		if($user ne $username && !${$uid.$user}{'userwasloadedfromcache'}) {$writecache = 1;}
		push(@userlist, $user);
	}
	if(!$writecache) {return;}
	foreach $user (@userlist) {
		my($filteredname, $filteredgroups, $filteredpos, $filtereddate);
		($filteredname = ${$uid.$user}{'realname'}) =~ s/\\/\\\\/g;
		($filteredgroups = ${$uid.$user}{'addgroups'}) =~ s/\\/\\\\/g;
		($filteredpos = ${$uid.$user}{'position'}) =~ s/\\/\\\\/g;
		($filtereddate = ${$uid.$user}{'regdate'}) =~ s/\\/\\\\/g;
		$output .= qq~
	\${\$uid.'$user'}{'realname'} = '$filteredname';
	\${\$uid.'$user'}{'addgroups'} = '$filteredgroups';
	\${\$uid.'$user'}{'position'} = '$filteredpos';
	\${\$uid.'$user'}{'regtime'} = '${$uid.$user}{'regtime'}';
	\${\$uid.'$user'}{'regdate'} = '$filtereddate';
	\${\$uid.'$user'}{'userwasloadedfromcache'} = 1;~;
		if($debug == 1) {$output .= qq~\n\t\$openfiles .= "(User loaded from cache) -&gt; $user<br />";~;} # Debug line
	}

	if(-e "$vardir/cachesettings.txt") {require "$vardir/cachesettings.txt";}
	else {
		fopen(USERCACHESETTINGS, ">$vardir/cachesettings.txt");
		print USERCACHESETTINGS qq~\$cachettl = 900;\n\n1;~; ### Default to 15 minutes.
		fclose(USERCACHESETTINGS);
		$cachettl = 900;
	}

	fopen(WRITEUSERCACHE, ">$vardir/boardindexusers.cache");
	print WRITEUSERCACHE 'if(', int(time) + $cachettl, ' > time) {';
	print WRITEUSERCACHE $output;
	print WRITEUSERCACHE "\n}\n\n1;";
	fclose(WRITEUSERCACHE);
}

</add before>

<search for>
	if ($totalt < 0) { $totalt = 0; }
	if ($totalm < 0) { $totalm = 0; }
</search for>

<add before>
	### AK108 Board Index User Cache
	RecacheUsers();

</add before>

<edit file>
Sources/MessageIndex.pl
</edit file>

<search for>
sub MessageIndex {
</search for>

<add before>
### AK108 Board Index User Cache
### Leech from the boardindex cache to steal the speed bonus, too.
if(-e "$vardir/boardindexusers.cache") {
	# Trap any syntax errors that might be in the file
	eval 'require "$vardir/boardindexusers.cache"';

	# You can trap errors here by uncommenting the following if statement
	# And putting something inside the block
	#if($@) {} # the code in the if block is executed if there is an error

	# It is probably a good idea to remove the file if it's bad.
	if($@) {unlink "$vardir/boardindexusers.cache";}
}

</add before>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
		# let's restore the name now
		&ToHTML($tempname);
		$member{'name'} = $tempname;
		&ToChars($member{'name'});
</search for>

<add after>

		### AK108 Board Index User Cache
		# See if it needs to be recached by seeing if this user had a crucial item changed
		if(${$uid.$user}{'realname'} ne $member{'name'}) {
			&SingleUserRecache($user, 'realname', $member{'name'});
		}
</add after>

<search for>
	if ($member{'moda'} eq $profile_txt{'88'}) {
		if (!$iamadmin) { $member{'dr'} = ${$uid.$user}{'regdate'}; }
		$member{'addgroup'} =~ s/\A\,//;
</search for>

<add after>
		### AK108 Board Index User Cache
		# See if it needs to be recached by seeing if this user had a crucial item changed
		if(${$uid.$user}{'addgroups'} ne $member{'addgroup'} || ${$uid.$user}{'regdate'} ne $member{'dr'} || ${$uid.$user}{'position'} ne $member{'settings7'}) {
			&SingleUserRecache($user, 'addgroups regdate position', $member{'addgroup'}, $member{'dr'}, $member{'settings7'});
		}
</add after>

<search for>
1;
</search for>

<add before>
#### AK108 Board Index User Cache
### This subroutine recaches the current user only due to a profile change.
sub SingleUserRecache { # Usage: &SingleUserRecache($user, 'space delimited user fields to update', @list_of_variables_to_update_with);
	my($user, @cache, $line, %updatefield, $i, @keylist, @valuelist);
	if(-e "$vardir/boardindexusers.cache") {require "$vardir/boardindexusers.cache";}
	else {return 0;}

	$user = $_[0]; # Dunno if $user is local in the above routines, but this way is safer.
	if(!${$uid.$user}{'userwasloadedfromcache'}) {return 0;} # This user wasn't in the cache

	# Build find and replace hash
	@keylist = split(/\ /, $_[1]);
	#shift @_; # Knock off the front two values
	#shift @_;
	for($i = 0; $i < scalar @keylist; $i++) {
		#if(!2+$i < scalar @_) {$yymain .= qq~<em>last</em>~; last;}
		$updatefield{$keylist[$i]} = $_[2+$i];
		#$yymain .= qq~<b>$keylist[$i]</b><i>$updatefield{$keylist[$i]}</i><br />~;
	}

	#$yymain .= q~<hr>~;

	# Now, since Y2 doesn't provide an easy way to find out who's loaded (like keeping a hash or list),
	# we'll just open up the file, and use regexs to substitue this user's values.
	fopen(SINGLEUSERRECACHE, "$vardir/boardindexusers.cache");
	@cache = <SINGLEUSERRECACHE>;
	fclose(SINGLEUSERRECACHE);

	chomp @cache;
	foreach $line (@cache) {
		if($line =~ /\A\t\$\{\$uid\.\'$user\'\}\{\'(\w+)\'\}/) {
			#$yymain .= qq~match: <s>$1</s><br />~;
			if($updatefield{$1}) {
				my($change, $field) = ($updatefield{$1}, $1);
				$change =~ s/\\/\\\\/g;
				$line = qq~	\${\$uid.'$user'}{'$field'} = '$change';~;
				#$yymain .= qq~line: <u>$line</u><br />~;
			}
		}
	}

	fopen(SINGLEUSERRECACHE, ">$vardir/boardindexusers.cache");
	print SINGLEUSERRECACHE join("\n", @cache);
	fclose(SINGLEUSERRECACHE);

	#&fatal_error();
}

</add before>

<edit file>
Admin/AdminSubList.pl
</edit file>

<search for>
%director=(
</search for>

<add after>
'boardindexusercache', "BIUC.pl&BIUCMain",
'biucsettings2', "BIUC.pl&BIUCSettings2",
'biucinvalidate2', "BIUC.pl&BIUCInvalidate2",
</add after>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### BOARDMOD ANCHOR ###
</search for>

<add after>

	$boardindexusercache = 'Board_Index_User_Cache|AK108|This mod speeds up Board Index and Message Index views by using a cache of the users to display.|1.4|November 10th, 2005';
	push (@installed_mods, $boardindexusercache);
</add after>

<edit file>
AdminIndex.pl
</edit file>

<search for>
### BOARDMOD ANCHOR ###
</search for>

<add after>

	$boardindexusercache = 'boardindexusercache|Board Index User Cache|Board Index User Cache|';
	push (@boardmod_mods, $boardindexusercache);
</add after>
